VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "draw_Arc"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' The PictureBox we draw on.
Public picCanvas As PictureBox

' The rectangle's drawing attributes.
Public X0 As Single
Public Y0 As Single
Public start_angle As Single
Public stop_angle As Single

Public radius As Single
Public DrawWidth As Integer
Public ForeColor As OLE_COLOR
Public FillColor As OLE_COLOR
Public FillStyle As FillStyleConstants

' True if the object is selected.
Public Selected As Boolean
Public Sub Draw()
    ' See if the object is selected.
    If Selected Then
        ' It is selected.
        ' Draw in yellow to highlight it.
        picCanvas.ForeColor = vbYellow
    Else
        ' It is not selected.
        ' Use its normal ForeColor.
        picCanvas.ForeColor = ForeColor
    End If

    ' Set other drawing attributes.
    With picCanvas
        .FillStyle = FillStyle
        .FillColor = FillColor
        .DrawWidth = DrawWidth
    End With

    ' Draw the center of the ARC
    picCanvas.Line (X0, Y0)-(X0, Y0), picCanvas.ForeColor
    'picCanvas.Circle (X0, Y0), radius, picCanvas.ForeColor
    DrawArrowArc X0, Y0, radius, start_angle, stop_angle
End Sub
' Return True if the object is at this position.
Public Function IsAt(ByVal X As Single, ByVal Y As Single) As Boolean
    IsAt = (X0 - X) * (X0 - X) + (Y0 - Y) * (Y0 - Y) < radius * radius
End Function


' Set some defaults.
Private Sub Class_Initialize()
    DrawWidth = 1
    ForeColor = vbBlack
    FillColor = vbWhite
    FillStyle = vbFSSolid
End Sub


Private Sub DrawArrowArc(ByVal Cx As Single, ByVal Cy As Single, ByVal radius As Single, ByVal start_angle As Single, ByVal stop_angle As Single)
Dim endx As Single
Dim endy As Single
Dim dx As Single
Dim dy As Single

    picCanvas.Circle (Cx, Cy), radius, picCanvas.ForeColor, start_angle, stop_angle

    ' Get the arc's end point.
    endx = Cx + radius * Cos(stop_angle)
    endy = Cy - radius * Sin(stop_angle)

    ' Get the reverse direction of the circle at the end point.
    dx = -Sin(stop_angle)
    dy = -Cos(stop_angle)

    ' Draw the arrowhead.
    DrawArrowHead endx, endy, endx + dx, endy + dy, 20
End Sub

' Draw an arrowhead at (x2, y2) pointing in the direction
' from (x1, y1) --> (x2, y2).
Private Sub DrawArrowHead(ByVal x1 As Single, ByVal y1 As Single, ByVal x2 As Single, ByVal y2 As Single, ByVal arm_length As Single)
Dim dx As Single
Dim dy As Single
Dim length As Single

    dx = x2 - x1
    dy = y2 - y1
    length = Sqr(dx * dx + dy * dy)
    If length = 0 Then Exit Sub

    dx = dx / length * arm_length
    dy = dy / length * arm_length
    picCanvas.Line (x2, y2)-Step(-dx - dy, -dy + dx)
    picCanvas.Line (x2, y2)-Step(-dx + dy, -dy - dx)
End Sub
